#!/bin/bash

#PoC solution of reprioritization = 

: ${AQMS:="CBQ-DropTail CBQ-SFQ DropTail RED"}; #AQM="DropTail RED SFQ DRR CHOKE CoDel"	# active queue management setting
: ${TCC:="ledbat"}	  	; #TCC="ledbat lp nice reno"					# low-priority congestion control type
: ${WLD:="9"}			; #WLD="0 1 2 3 4 5 6 7 8 9"					# workload 0 - 9 (represent 0.1 - 1.0)
: ${BUF:="400"}			; #BUF="100 350"     							# buffer size [pkts]
: ${CAP:="1"}			; #CAP="10 1 0.5"								# link capacity [Mbps]
: ${RUN:="08659 13721 23632 36896 47416 6896 47416 56731 60476 76466"}
: ${TIME:="60"}			; # duration of simulation [seconds]
: ${DELAY:="0"}	        ; # incremental delay for flows
: ${NUM:="2"}           ; # number of flows
: ${LOW:="1"} 			; # number of low-priority flows
: ${TAU:="1000"}	 	; # delay target 1000=100ms
: ${AQM_RED_MIN:="10"}
: ${AQM_RED_MAX:="400"}
: ${AQM_RED_P:="0.1"}   ; #0.25 0.5 1.0 

for AQM in $AQMS; do
	mkdir raw 
	tag="$AQM"
	
	# not elegant but effective 
	if [[ $AQM == "CBQ-DropTail" ]];
	then
		AQM=CBQ
		CBQ_QTYPE=DropTail 
	elif [[ $AQM == "CBQ-SFQ" ]];
	then
		AQM=CBQ
		CBQ_QTYPE=SFQ
	fi

	for run in $RUN; do
		echo "$tag ($SECONDS sec)"
		./poc-tompecs-solution.tcl endtime $TIME inc_delay $DELAY \
			aqm $AQM cbq_qtype $CBQ_QTYPE tcp_type $TCC workload $WLD buffer_size $BUF capacity $CAP seed $run \
			nodes_num 2 nodes_low_prio 1 target $TAU \
			aqm_red_min $AQM_RED_MIN aqm_red_max $AQM_RED_MAX aqm_red_p $AQM_RED_P \
			tag $tag.run$run  > log.$tag.run$run 2> /tmp/err
		if [[ $? -gt 0 ]]; 
		then 
			cat log.$tag /tmp/err
			exit
		fi	

		./data-process.py -n 1 -c $CAP -t $TIME $tag.run$run.DATA > $tag.run$run.STAT	; # $(()) for integer arithmetics

		mv log.$tag* $tag* raw 
	done
	
	echo "[AVG] statistics generation..."
	./stat-process.py -l r raw/$tag.*.STAT > $tag.STAT
	mv raw raw.$tag
done

# quickly get to see average ^a  or average and variance ^[av] over all results
(echo -n "#"; head -n1 CBQ-DropTail.STAT; grep ^a *STAT ) |  sed 's/.STAT:a//' | awk '{ print $1, $2, $3, $NF }' | column -t  | tee summary.STAT

gnuplot summary.gp
