#! /home/drossi/simulation/ns/ns-allinone-2.33/ns-2.33/ns
# --------------------- 
# .:nonsns:. is going back to ns2 simulations in 2016, and he's happy to see he's still good at that.
#			 at the same time, he does not think he should have been the guy doing this....
# anyhow, please go to http://perso.telecom-paristech.fr/~drossi/index.php?n=Dataset.LEDBATAQM to understand 
#			what this scripts are about; and just run `make' to get all the magic ;)
# --------------------- 


set ns [new Simulator]

set opt(tag) "poc-tompecs"  	;# tag for output

# seed the default RNG
set opt(seed) 12345

#nodes
set opt(endtime) 1200
set opt(nodes_num) 10        	;# total number of flows
set opt(nodes_low_prio) 5   	;# number of low-priority flows
set opt(tcp_type) reno			;# use this to mean TCP-LP, TCP-NICE etc.
set opt(aqm) DropTail			;# use this to change AQM: DropTail, RED, SFQ, DRR, CBQ
set opt(cbq_qtype) RED          ;# CBQ: DropTail RED 


#curently no use (code deleted)
set opt(do_delay) 0
set opt(delay_interval) 600
set opt(delay_inc) 30
set opt(rtt_incremental_factor) 1 ;# 2nd flow RTT is rtt_incremental_factor biggers than 1st

set opt(do_cbr) 0
set opt(cbr_interval) 240
set opt(cbr_rate) 6e6

set opt(do_tcp) 0
set opt(tcp_normal_start) 60
set opt(tcp_normal_stop)  120
set opt(tcp_interval) 1200	;# 240
set opt(tcp_slow_start) 0
set opt(tcp_max_ssthresh) 0

#monitor
set opt(mon_interval) 0.1
set opt(do_trace) 0

#ledbat
set opt(target) 25
set opt(noise_filter_len) 3
set opt(base_histo_len) 100
set opt(alpha1) 1
set opt(alpha2) 1
set opt(min_impl) 0
set opt(target_impl) 0
set opt(ledbat_slow_start) 0
set opt(ledbat_ssthresh)   'heuristic'
set opt(ssthresh_factor)    1.0

#aqm red
set opt(aqm_red_min) 10
set opt(aqm_red_max) 100
set opt(aqm_red_p)   1.0

set opt(dumb_tcp_for_model) 0
set opt(debug_tcp) 1

#for setupflows()
set opt(tcp_ledbat_start) 0
set opt(inc_delay) 0
set opt(inc_start_time) 0
set opt(random_start_time) 0
set opt(start_delay) 6

set opt(pacing) 0
set opt(randpacing) 0
set opt(standard_tcp) 0

#in packets
set opt(buffer_size) 100
#in Mb
set opt(capacity) 10
#in ms
set opt(RTT)      50
set opt(interval) [expr 2.0 * $opt(RTT) / 1000.0]

#workload
set opt(workload)	9	;# workload + 1 = real workload

#global options
set opt_list [ array names opt ]

global tcp_normal_oldack
set tcp_normal_oldack 0

if { [expr [lsearch -exact $argv "help"] > -1 ] } {
	puts [join $opt_list "\n"]
	exit
}

foreach i $opt_list {
	set index [lsearch -exact $argv $i]
	if { [expr $index > -1] } {
		set val [lindex $argv [expr $index+1]];
		puts "set $i to $val";
		set opt($i) $val;
	}
}


#seeding the default rng
#global defaultRNG
$defaultRNG seed $opt(seed)
puts $opt(seed)

#if {$opt(inc_start_time) > 0} {
set a [ $defaultRNG uniform 0 0.100 ]
set opt(tcp_ledbat_start) [ expr $opt(tcp_ledbat_start) + $a ]
puts $opt(tcp_ledbat_start)
	#exit
#}

#Create trace
#set tf [open all.tr w]
#set namf [open out.nam w]
#if {$opt(do_trace)} {
#	$ns trace-all $tf
#	$ns namtrace-all $namf
#}

#setup color names
$ns color 1 Blue
$ns color 2 Red

# GIO
if { $opt(dumb_tcp_for_model) } {
	Agent/TCP set noFastRetrans_ true
	Agent/TCP set slow_start_restart_ false
	Agent/TCP/Newreno set noFastRetrans_ true
	Agent/TCP/Newreno set noFastRetrans_ true
	Agent/TCP/Linux set slow_start_restart_ false
	Agent/TCP/Linux set slow_start_restart_ false
	set ssthresh      1000
	set MaxWinSize    1000
	Agent/TCP  	  set maxcwnd_		$MaxWinSize
	Agent/TCP	  set window_		$ssthresh
	Agent/TCP/Newreno set maxcwnd_		$MaxWinSize
	Agent/TCP/Newreno set window_		$ssthresh
	Agent/TCP/Linux set maxcwnd_		$MaxWinSize
	Agent/TCP/Linux set window_		$ssthresh

	set opt(tcp_slow_start) 0
	set opt(tcp_max_ssthresh) 2

} else {
	Agent/TCP set noFastRetrans_ false
	Agent/TCP set slow_start_restart_ true
	Agent/TCP/Newreno set noFastRetrans_ false
}
 

Agent/TCP/Newreno set packetSize_ 1500
Agent/TCP set packetSize_ 1500
Agent/TCP/Linux set packetSize_ 1500
Agent/TCP/Linux set window_ 80000
Agent/TCP/Linux set interval_ 0
#Agent/TCP/Newreno set interval_ 0
#Agent/TCPSink/DelAck  set interval_ 0

if { $opt(ledbat_ssthresh) eq "heuristic" } {
    # achieve half of the target in slow start
    set opt(ledbat_ssthresh) [expr round ($opt(ssthresh_factor) *  ($opt(target)/1000.0)*( $opt(capacity)*1.0e6 )/(1500*8.0)  ) ]
    puts "SSTHRESH_FACTOR $opt(ledbat_ssthresh)"
    
    if { $opt(ledbat_slow_start) < 1 } {
  	  set opt(ledbat_ssthresh) 0
  	  puts "NO_SSTHRESH $opt(ledbat_ssthresh)"    
    }        
}

#let's do this only for the ledbat agents
#Agent/TCP/Linux set max_ssthresh_ $opt(ledbat_ssthresh)
#Agent/TCP/Linux set ssthresh_ 100

#Create the two routers
set router(0) [$ns node]
set router(1) [$ns node]
$router(0) label "R0"
$router(1) label "R1"

#setup the link between the routers
Queue/RED set thresh_ $opt(aqm_red_min)
Queue/RED set maxthresh_ $opt(aqm_red_max)
Queue/RED set q_weight_ 0.02

# WEIRD ns2 nonsns; cur_max_p_ is actually set to 1/inv_max_p in C++ which is bound to ...linterm_
Queue/RED set cur_max_p_ $opt(aqm_red_p)
Queue/RED set linterm_ [expr (1.0/ $opt(aqm_red_p)) ]
Queue/RED set max_p_ $opt(aqm_red_p)
Queue/RED set stacippa_ 33cm

Queue/RED set gentle_ false
Queue/RED set mean_pktsize_ 1500

set link_delay [expr (0.0 + $opt(RTT)) / 2.0 - 4.0 ]


if { $opt(aqm) == "CBQ" } { 
    puts "CBQ Proof-of-Concept solution of LPCC+AQM reprioritizaion phenomenon"
    puts "$opt(aqm):$opt(cbq_qtype)"	
	$ns simplex-link $router(0) $router(1) "$opt(capacity)Mb" "${link_delay}ms" "$opt(aqm)/WRR"		;# para:AQM
	set cbqlink [$ns link $router(0) $router(1)]

	set CBQroot [new CBQClass]
	# (topclass_ doesn't have a queue)
	$CBQroot setparams none 0 1 auto 8 2 0

	set BEclass [new CBQClass]
	set qBE [new Queue/$opt(cbq_qtype)]
	if { $qBE != "" } {
		$qBE set limit_ $opt(buffer_size) 
		$BEclass install-queue $qBE 
		$BEclass setparams $CBQroot true .99 auto 1 1 0
		#$BEclass setparams $CBQroot true .7 auto 1 1 0
		puts "Allocated CQB:BestEffort=$opt(cbq_qtype)"
	} else { 
		puts "Failed to allocate CQB:BestEffort=$opt(cbq_qtype)"
	}

	set LPCCclass [new CBQClass]
	set qLPCC [new Queue/$opt(cbq_qtype)]
	if { $qLPCC != "" } {
		$qLPCC set limit_ $opt(buffer_size) 
		$LPCCclass install-queue $qLPCC
		$LPCCclass setparams $CBQroot true .01 auto 2 1 0
		#$LPCCclass setparams $CBQroot true 0.3 auto 2 1 0
		puts "Allocated CQB:BestEffort=$opt(cbq_qtype)"
	} else { 
		puts "Failed to allocate CQB:BestEffort=$opt(cbq_qtype)"
	}

 	$cbqlink insert $CBQroot
	$cbqlink insert $BEclass 
    $cbqlink insert $LPCCclass 

	$cbqlink bind $BEclass    0;# fid 1
 	$cbqlink bind $LPCCclass  1;# fid 2

	[$cbqlink queue] algorithm "formal"
    puts "CBQ Configured"
 	
} else {
	$ns simplex-link $router(0) $router(1) "$opt(capacity)Mb" "${link_delay}ms" "$opt(aqm)"		;# para:AQM
}

$ns simplex-link $router(1) $router(0) "$opt(capacity)Mb" "${link_delay}ms" DropTail
$ns queue-limit $router(0) $router(1) $opt(buffer_size) 
$ns queue-limit $router(1) $router(0) $opt(buffer_size) 
$ns duplex-link-op $router(0) $router(1) orient right
$ns duplex-link-op $router(0) $router(1) queuePos 0.5

#set up the queue monitor
#set qmonf [open "$opt(tag).0510Q.DATA" w]
#set qmon [$ns monitor-queue $router(0) $router(1) $qmonf $opt(mon_interval)]
#[$ns link $router(0) $router(1)] start-tracing

#set up the flow monitor, which is QueueMonitor/ED/Flowmon, so no need to use queuemonitor at the same time
set fmonf [open "$opt(tag).$opt(nodes_num).$opt(nodes_low_prio).R.DATA" w]
set fmon [$ns makeflowmon Fid]
$ns attach-fmon [$ns link $router(0) $router(1)] $fmon

set router_bytes 0
set router_drops 0
set router_qsize_avg 0
set dataf [open "$opt(tag).DATA" w]

set ang [expr 180.0 / ( $opt(nodes_num) + 1) ]

set on [new RandomVariable/Exponential]
$on set avg_ [expr $opt(workload) + 1]
set off [new RandomVariable/Exponential]
$off set avg_ [expr 9 - $opt(workload)]

proc pauseflows { nodeid } {
	global ns ftp ftp_quota on off
	
	$ftp($nodeid) stop

	if {$ftp_quota($nodeid) > 0} {
		set now [$ns now]
		set burstlen [$on value]
		set interval [$off value]
		set ftp_quota($nodeid) [expr $ftp_quota($nodeid) - $burstlen]
		$ns at [expr $now + $interval] "$ftp($nodeid) start"
		$ns at [expr $now + $interval + $burstlen] "pauseflows $nodeid"
	}
}


proc setupflows { nodes_each {past_nodes 0} } {
    global ns opt defaultRNG router sender tcp ftp ftp_quota
    global ang thf sink flow_bytes flow_drops flow_cwnd_avg

    puts "-- setupflows -- flavor=$opt(tcp_type), how_many_nodes=$nodes_each, past_nodes=$past_nodes"

    #setup LEDBAT senders and receivers
    set tot_nodes [expr $nodes_each + $past_nodes ]
    for {set i $past_nodes} { [expr $i < $tot_nodes] } { incr i } {

    	#senders
    	set sender($i) [$ns node]
    	# desynchronizing TX & RX 
    	set jitter [ $defaultRNG uniform 0 0.100 ]
    	set delay [expr $opt(start_delay) + ($i - $past_nodes) * $opt(inc_delay)]   ;# $i - $past_nodes for same scenario of TCP/CC
    	puts "sender($i) router(0) link delay ${delay}";
    	$ns duplex-link $sender($i) $router(0) 100Mb "${delay}ms" DropTail
    	$ns duplex-link-op $sender($i) $router(0) orient "[expr ($i + 1) * $ang +270 ]deg"
    
    	#setup the tcp
    	if {$opt(standard_tcp)} {
    		puts "=========== Reno-$i"
    		set tcp($i) [new Agent/TCP/Reno]
    		$tcp($i) set fid_  $i ;#[expr  1+$i]
    	} else {
    		puts "=========== Linux-$i"
    		set tcp($i) [new Agent/TCP/Linux]
    				
    		$tcp($i) set_ca_param ledbat ledbat_ssthresh $opt(ledbat_ssthresh)
    		$tcp($i) set_ca_default_param linux debug_level $opt(debug_tcp)
    		$tcp($i) set_ca_param ledbat target $opt(target)
    		$tcp($i) set_ca_param ledbat min_impl $opt(min_impl)
    		$tcp($i) set_ca_param ledbat target_impl $opt(target_impl)
    		$tcp($i) set_ca_param ledbat noise_filter_len $opt(noise_filter_len)
    		$tcp($i) set_ca_param ledbat base_histo_len $opt(base_histo_len)
    		$tcp($i) set_ca_param ledbat alpha1 $opt(alpha1)
    		$tcp($i) set_ca_param ledbat alpha2 $opt(alpha2)
    		$tcp($i) set_ca_param ledbat do_ss $opt(ledbat_slow_start)

    		$tcp($i) set timestamps_ true
    		$tcp($i) select_ca $opt(tcp_type)
    		
    		puts "randpacing $opt(randpacing)"
    		$tcp($i) set pace_packet_ $opt(pacing)
    		$tcp($i) set randpacing_ $opt(randpacing)
    		$tcp($i) set fid_ $i ;#[expr  1+$i]
    		
    		if {$opt(pacing)} {
    			# normal tcp is never paced
    			Agent/TCP set pace_packet_ $opt(pacing)
    			Agent/TCP/Linux set pace_packet_ $opt(pacing)
    			Agent/TCP/Linux set randpacing_ $opt(randpacing)
    		}
    
    	}
    	    	
		$ns attach-agent $sender($i) $tcp($i)
    
    	# desynchronizing TX & RX 
    	# receivers
    	set receiver($i) [$ns node]
    	set jitter [ $defaultRNG uniform 0 0.100 ]
    	set delay  [expr 2 + $jitter ]
    	$ns duplex-link $router(1) $receiver($i) 100Mb ${delay}ms DropTail
    	$ns duplex-link-op $router(1) $receiver($i) \
    		orient "[expr ($i + 1) * $ang + 270 ]deg"
    
    	#setup the sink
		set sink($i) [new Agent/TCPSink/Sack1]	    	;#set sink($i) [new Agent/LossMonitor] LossMonitor can be only used on CBR flow!!
    	$sink($i) set ts_echo_rfc1323_ true
    	$ns attach-agent $receiver($i) $sink($i)

    	#set thf($i) [open "throuput.$opt(tcp_type).$i.$opt(tag).DATA" w]
    	set thf($i) [open "$opt(tag).$opt(nodes_num).$opt(nodes_low_prio).$i.DATA" w]				;# para: Filename

    	#connections
    	$ns connect $tcp($i) $sink($i)
    	
		#initialize flow stats
		set flow_bytes($i) 0
		set flow_drops($i) 0
		set flow_cwnd_avg($i) 0

    	#ftp applications 
    	set ftp($i) [new Application/FTP]
    	$ftp($i) attach-agent $tcp($i)
    	$ftp($i) set type_ FTP
    
    	$tcp($i) set class_ $i ;#[expr  1+$i]
    	$tcp($i) set fid_ $i ;#[expr  1+$i]
        $sender($i) color Blue
      	$sender($i) label $opt(tcp_type)
    
    	#start flows
    	set st [expr $i * $opt(inc_start_time)]
    	#random start time 
    	if {$opt(random_start_time) != 0} {
    		set st [ $defaultRNG uniform 0 $opt(random_start_time)]
    	} 
		
    	set t [expr $opt(tcp_ledbat_start) + $st ]
    	puts "ftp($i) start at $t"
    	#  [$defaultRNG uniform 0 0.1]
    	$ns at $t "$ftp($i) start"

        if {$opt(workload) < 9} {
            set ftp_quota($i) [expr $opt(endtime) * ($opt(workload) + 1) / 10]
		    $ns at [expr $t + 0.1] "pauseflows $i"
        }
    }
}

# Setup the multiple flows
set flavor $opt(tcp_type)    ;#save low-pri flavor

# start the TCP flows
set opt(tcp_type) reno       ;#cubic
set tcp_nodes [expr $opt(nodes_num) - $opt(nodes_low_prio)]
puts "nodes_num $opt(nodes_num) nodes_low_prio $opt(nodes_low_prio) tcp_nodes $tcp_nodes"
setupflows $tcp_nodes 0

# start the low-priority flows
set opt(tcp_type) $flavor
setupflows $opt(nodes_low_prio) $tcp_nodes

#print things
proc flowdump {} {
	global ns fmon fmonf tcp thf opt sink
	global router_bytes router_drops router_qsize_avg flow_bytes flow_drops flow_cwnd_avg

	set now [format "%0.1f" [$ns now]]	;# format output

	#print data from flow monitor...
	#$fmon dump

	for {set i 0} { [expr $i < $opt(nodes_num)] } { incr i } {
	#puts "$now $i"	
		if { $now >= [expr $opt(tcp_ledbat_start) + $i * $opt(inc_start_time) ] } {
			set cwnd [$tcp($i) set cwnd_]
		} else {
			set cwnd 0
		}
	
		if {$now != 0} {
			set cwnd_avg [expr $flow_cwnd_avg($i)*(1-$opt(interval)/$now) + $cwnd*$opt(interval)/$now]
			set flow_cwnd_avg($i) $cwnd_avg
		}
		#Old way using TCPSink
		#set bytes [$sink($i) set bytes_]
		#set flow_bytes($i) [expr $flow_bytes($i) + $bytes]
		#set throuput [expr $bytes / $opt(interval) * 8 / 1000]	;#KBit/s
		#$sink($i) set bytes_ 0
		#puts $thf($i) "$now $throuput $flow_bytes($i) $cwnd" ;# $bytes
		
		set fclassifier [$fmon classifier]
		set flow [$fclassifier lookup auto 0 0 $i]
		if {$flow != "" } {
			set bytes [$flow set bdepartures_]
			set throuput [expr ($bytes - $flow_bytes($i)) / $opt(interval) * 8 / 1000] 	;#KBytes/s?
			set flow_bytes($i) $bytes
			
			set drops [$flow set pdrops_]
			set insdrop [expr $drops - $flow_drops($i)]
			set flow_drops($i) $drops

			puts $thf($i) "$now $throuput $bytes $insdrop $drops $cwnd $flow_cwnd_avg($i)"
		} else {
			puts $thf($i) "$now 0 0 0 0 $cwnd $flow_cwnd_avg($i)"
		}
	}	

	# print router info: queue size, throuput, drops
	set r_qsize [$fmon set pkts_]
	if {$now != 0} {
		set r_qsize_avg [expr $router_qsize_avg*(1-$opt(interval)/$now) + $r_qsize*$opt(interval)/$now]
		set router_qsize_avg $r_qsize_avg
	}
	
	set r_bytes [$fmon set bdepartures_]
	set r_throuput [expr ($r_bytes - $router_bytes) / $opt(interval) * 8 / 1000]	;#KBit/s
	set router_bytes $r_bytes

	set r_drops [$fmon set pdrops_]
	set r_insdrop [expr $r_drops - $router_drops]
	set router_drops $r_drops
	puts $fmonf "$now [format %0.1f $r_throuput] $r_bytes $r_insdrop $r_drops $r_qsize [format %0.1f $router_qsize_avg]"

	#reschedule printing
	$ns at [expr $now + $opt(interval)] flowdump
}

$ns at 0.0 flowdump

proc finish {} {
	global opt dataf fmon flow_bytes flow_cwnd_avg flow_drops router_bytes router_qsize_avg

	puts $dataf "item bytes droprate cwnd_avg qsize_avg"

	for {set i 0} { [expr $i < $opt(nodes_num)] } { incr i } {

		set fclassifier [$fmon classifier]
		set flow [$fclassifier lookup auto 0 0 $i]
		if {$flow != "" } {
			set arrivals [$flow set parrivals_]
			set droprate [expr 1.00 * $flow_drops($i) / $arrivals]	;# 1.0 convert result to float
			set cwnd_avg [format %0.2f $flow_cwnd_avg($i)]
			puts $dataf "$i $flow_bytes($i) $droprate $cwnd_avg x"	;#KBytes
		} else {
			set cwnd_avg [format %0.2f $flow_cwnd_avg($i)]
			puts $dataf "$i $flow_bytes($i) x $cwnd_avg x"
		}
	}	

	set r_droprate [expr 1.0 * [$fmon set pdrops_] / [$fmon set parrivals_]]
	set r_qsize_avg [format %0.2f $router_qsize_avg]
	puts $dataf "R $router_bytes $r_droprate x $r_qsize_avg"

	exit 0
}

#Schedule the stop of the simulation
$ns at [expr $opt(endtime)] "finish"

puts "Let start this"
#Start the simulation
$ns run

exit 0
